#DEFINE CRLF CHR(13) + CHR(10)

DEFINE CLASS FoxServer as SESSION OLEPUBLIC

cAppStartPath = ""

lError = .F.
cErrorMsg = ""


************************************************************************
* FoxServer :: Init
*********************************
***  Function: Set the server's environment. IMPORTANT!
************************************************************************
FUNCTION INIT

*** Make all required environment settings here
*** KEEP IT SIMPLE: Remember your object is created
***                 on EVERY ASP page hit!
SET RESOURCE OFF   && Best to compile into a CONFIG.FPW
SET EXCLUSIVE OFF
SET REPROCESS TO 2 SECONDS

SET CPDIALOG OFF
SET DELETED ON
SET EXACT OFF
SET SAFETY OFF


*** IMPORTANT: Figure out your DLL startup path
IF application.Startmode = 3 OR Application.StartMode = 5
	THIS.cAppStartPath = ADDBS(JUSTPATH(Application.ServerName))
ELSE
    THIS.cAppStartPath = SYS(5) + ADDBS(CURDIR())
ENDIF

*** If you access VFP data you probably will have to
*** use this path plus a relative path to get to it!
*** You can SET PATH here, or else always access data
*** with the explicit path
SET PATH TO (THIS.cAppStartpath) ADDITIVE
SET PATH TO (THIS.cAppStartPath + "DATA") ADDITIVE

ENDFUNC


************************************************************************
* FoxServer :: GetRequestInfo
*********************************
***  Function: returns the currently active Request info
************************************************************************
Function GetRequestInfo(llForceToSystem as Boolean) as String

IF llForceToSystem
  DECLARE INTEGER RevertToSelf ;
      IN WIN32API
  RevertToSelf()
ENDIF      
  
DECLARE Integer GetUserName ;
   IN WIN32API AS GUserName ;
   STRING @nBuffer, ;
   INTEGER @nBufferSize

lcUserName=space(255)
lnLength=len(lcUserName)

lnError=GUserName(@lcUserName,@lnLength)
IF lnLength < 2
   RETURN ""
ENDIF   

lcUserName = SUBSTR(lcUsername,1,lnLength-1)
lcPath = SYS(5) + CURDIR()

lcOutput = "Current Path: " + lcPath + CRLF +;
		   "    DLL Path: " + this.cAppStartPath + CRLF +;
           "Current User: " + lcUserName + " - " + SYS(0) + CRLF + ;
           "Current Thread: " + TRANSFORM( Application.ThreadId) + CRLF

RETURN lcOutput


************************************************************************
* FoxServer :: Error
*********************************
***  Function: Error Method. Capture errors here in a string that
***            you can read from the ASP page to check for errors.
************************************************************************
PROTECTED FUNCTION ERROR
LPARAMETER nError, cMethod, nLine
this.lError = .t.
THIS.cErrorMsg=THIS.cErrorMsg + CRLF + "Error No: " + STR(nError) + CRLF +"  Method: " + cMethod + CRLF +"  LineNo: " +STR(nLine) + CRLF + "  Message: "+ message() + Message(1) + CRLF + CRLF
ENDFUNC

ENDDEFINE




DEFINE CLASS Customer as Session OlePublic

cName = "Rick Strahl"
cCompany = "West Wind Technologies"
cAddress = "32 Kaiea Place"
tEntered = DATETIME()
oPhoneNumbers = null

DIMENSION cName_COMATTRIB[4]
cName_COMATTRIB[1] = 0  && Full Access
cName_COMATTRIB[2] = "Customer Name"
cName_COMATTRIB[3] = "cName"  && Proper capitalization.
cName_COMATTRIB[4] = "string"        && Data type

DIMENSION cCompany_COMATTRIB[4]
cCompany_COMATTRIB[1] = 0  && Full Access
cCompany_COMATTRIB[2] = "Customer Company"
cCompany_COMATTRIB[3] = "cCompany"  && Proper capitalization.
cCompany_COMATTRIB[4] = "string"        && Data type

DIMENSION cAddress_COMATTRIB[4]
cAddress_COMATTRIB[1] = 0  && Full Access
cAddress_COMATTRIB[2] = "Customer Address"
cAddress_COMATTRIB[3] = "cAddress"  && Proper capitalization.
cAddress_COMATTRIB[4] = "string"        && Data type

DIMENSION tEntered_COMATTRIB[4]
tEntered_COMATTRIB[1] = 0  && Full Access
tEntered_COMATTRIB[2] = "Date this customer was entered"
tEntered_COMATTRIB[3] = "tEntered"  && Proper capitalization.

*** DOESN'T WORK - conversions fail in .NET TlbImport!
*tEntered_COMATTRIB[4] = "Date"        && Data type

DIMENSION oPhoneNumbers_COMATTRIB[4]
oPhoneNumbers_COMATTRIB[1] = 0x100000  && ReadOnly Access
oPhoneNumbers_COMATTRIB[2] = "Error Message for any functions"
oPhoneNumbers_COMATTRIB[3] = "oPhoneNumbers"  && Proper capitalization.

*** Doesn't work - use default
*oPhoneNumbers_COMATTRIB[4] = "Object"        && Data type


FUNCTION INIT
*** Note we have to create COM object otherwise you can't
*** cast in the .NET code
This.oPhoneNumbers = CREATEOBJECT("FoxService.PhoneNumbers")
ENDFUNC


ENDDEFINE

DEFINE CLASS PhoneNumbers as Session OlePublic

cTelephone = "808 123-1231"
cFax = "808 332-1231"
cMobile = "808 312-1231"

DIMENSION cTelephone_COMATTRIB[4]
cTelephone_COMATTRIB[1] = 0  && Full Access
cTelephone_COMATTRIB[2] = "Main Phone Number"
cTelephone_COMATTRIB[3] = "cTelephone"  && Proper capitalization.
cTelephone_COMATTRIB[4] = "string"        && Data type

DIMENSION cFax_COMATTRIB[4]
cFax_COMATTRIB[1] = 0  && Full Access
cFax_COMATTRIB[2] = "Fax phone number"
cFax_COMATTRIB[3] = "cFax"  && Proper capitalization.
cFax_COMATTRIB[4] = "string"        && Data type

DIMENSION cMobile_COMATTRIB[4]
cMobile_COMATTRIB[1] = 0  && Full Access
cMobile_COMATTRIB[2] = "Mobile Phone Number"
cMobile_COMATTRIB[3] = "cMobile"  && Proper capitalization.
cMobile_COMATTRIB[4] = "string"        && Data type

ENDDEFINE



