PRIVATE lows9_test AS "XML Web Service"
* LOCAL lows9_test AS "MSSOAP.SoapClient30"
* Do not remove or alter following line. It is used to support IntelliSense for your XML Web service.
*__VFPWSDef__: lows9_test = http://juanxpdt/vfpWS/ws9_test.WSDL , ws9_test, ws9_testSoapPort
LOCAL loException, lcErrorMsg, loWSHandler
TRY
	CLEAR
	SET safety off 
	loWSHandler = NEWOBJECT("WSHandler",IIF(VERSION(2)=0,"",HOME()+"FFC\")+"_ws3client.vcx")
	lows9_test = loWSHandler.SetupClient("http://juanxpdt/vfpWS/ws9_test.WSDL", "ws9_test", "ws9_testSoapPort")


	* this line stores the datetime value before querying/updating
	?"* Get server time"
	?"Started:  ",DATETIME()
	lcLastUpd = lows9_test.GetServerTime()
	?lcLastUpd
	?"Ended:  ",DATETIME()

	*Saving the last datetime updated
	STRTOFILE(TTOC(lcLastUpd),"LastTimeUpdated.TXT",0)

	* Simply Testing 2 methods
	?lows9_test.GetServerTime()
	?lows9_test.ReturnPath()


*!*		* Run Download DATA PAging using IID"
*!*		lnRecords=DownLoadTable("Classes",1000,'DownLoadDataPaging','IID')
*!*		?"Records Imported: "+STR(lnRecords)
*!*		?"*********************************"

*!*		* Run Download DATA PAging WITHOUT using IID"
*!*		lnRecords=DownLoadTable("Classes",200,'DownLoadDataPagingWPK','cROOM+cMEETING')
*!*		?"Records Imported: "+STR(lnRecords)
*!*		?"*********************************"
	
	* Run Download DATA PAging Incremental Since Last Query/Update
	lnRecords=DownLoadTable("Classes",1000,'DownLoadDataPagingSinceLastUpdate','IID')
	?"Records Imported: "+STR(lnRecords)
	?"*********************************"



	* Uploading data directly to the table"
	lnRecords=RunUploadDataPaging("")
	?"Records uploaded: "+STR(lnRecords)
	?"*********************************"

	* Uploading data using a view"
	lnRecords=RunUploadDataPaging("VIEW")
	?"Records Uploaded Using a View: "+STR(lnRecords)
	?"*********************************"



CATCH TO loException
	lcErrorMsg="Exception #: "+;
		TRANSFORM(loException.ERRORNO)+CHR(13)+;
		"LINE "+ALLTRIM(STR(loException.LINENO))+": "+loException.LINECONTENTS+CHR(13)+;
		"MESSAGE : "+loException.MESSAGE+CHR(13)+;
		"DETAILS : "+loException.DETAILS+CHR(13)

	DO CASE
		CASE VARTYPE(lows9_test)#"O"
			* Handle SOAP error connecting to web service
		CASE !EMPTY(lows9_test.FaultCode)
			* Handle SOAP error calling method
			*lcErrorMsg = "Exception: "+TRANSFORM(loException.ERRORNO) + CHR(13)+ "Web Service DETAIL:"+CHR(13)+lows9_test.DETAIL
		OTHERWISE
			* Handle other error
	ENDCASE
	* Use for debugging purposes
	MESSAGEBOX(lcErrorMsg)
FINALLY
ENDTRY

******************************************************************************************************************************************
PROCEDURE DownLoadTable(tcTable AS CHARACTER, tiPageSize AS INTEGER, tcWSMethod AS CHARACTER, tcLastIDKey AS CHARACTER) AS INTEGER
	******************************************************************************************************************************************
	LOCAL 	lnRecords, liLastID, lcLastID,	liPageSize, lnRecordsImported, lcReturnPage 
	IF USED(tcTable)
		USE IN (tcTable)
	ENDIF
	
	* DELETE FILE tcTable+".dbf"
	?"***  Running "+PROGRAM()
	?"Started Data Paging:",DATETIME()
	lnRecords = -1


	IF tcLastIDKey="IID"
		licLastID   = 0
	ELSE
		licLastID   = SPACE(50)
	ENDIF

	liPageSize = tiPageSize

	ltLastTimeUpdated=getLasTimeWebServiceUpdatedValue()

	lnRecordsImported=0

	DO WHILE lnRecords#0
		DO CASE
			CASE UPPER(tcWSMethod) = UPPER("DownLoadDataPagingWPK")
				lcReturnPage = lows9_test.DownLoadDataPagingWPK(tcTable, licLastID, liPageSize)
			CASE UPPER(tcWSMethod) = UPPER("DownLoadDataPagingSinceLastUpdate")
				IF ltLastTimeUpdated < DATETIME()
					lcReturnPage = lows9_test.DownLoadDataPagingSinceLastUpdate(tcTable,ltLastTimeUpdated,liPageSize)
					
				ELSE
					EXIT
				ENDIF
			OTHERWISE
				lcReturnPage = lows9_test.DownLoadDataPaging(tcTable,licLastID,liPageSize)
		ENDCASE

		lnRecords = XMLTOCURSOR(lcReturnPage,"TableTemp")
		lnRecordsImported = lnRecordsImported + lnRecords

		IF lnRecords=0
			USE IN TableTemp
			EXIT
		ENDIF

		SELECT TableTemp
		GO BOTT
		licLastID = EVALUATE(tcLastIDKey)
		ltTableTempName = DBF()

		IF !FILE(tcTable+".DBF")
			SELECT * FROM TableTemp INTO TABLE (tcTable)
		ELSE
			SELECT (tcTable)
			APPEND FROM (ltTableTempName )
		ENDIF
		USE IN TableTemp

		IF lnRecordsImported>=3000
			*!*	          Stop the process: just in case we had enoug testing. 
			*!*				?"Partial:  ", DATETIME(), " Records:", lnRecordsImported
			*!*				SUSPEND
		ENDIF

	ENDDO
	?"Ended Data Paging  :",DATETIME()
	IF USED(tcTable)
		SELECT (tcTable)
		lnRecords=RECCOUNT()
	ENDIF 
	CLOSE DATABASES all
	RETURN lnRecords
ENDPROC
******************************************************


******************************************************
PROCEDURE RunUploadDataPaging(tView AS CHARACTER) AS INTEGER
	* Web Service Method Returns Integer as follows:
	*	-5 : Buffering 5 FAILED
	*	-3 : Buffering 3 FAILED
	*	-1 : Update FAILED
	*	0 : Empty XML - No records to process
	*	1 : Update Succesful

	?"***  Running "+PROGRAM()
	
	DELETE FILE class_NU.dbf

    SELECT 0
	USE classes.dbf
	COUNT FOR !DELETED() TO lntotalRecords
	COPY STRUCTURE TO Class_NU
	
	SELECT 0
	USE Class_NU
	
	
	SELECT classes 
	ltDTMODI=DATETIME()-(3600*24)
	REPLACE dtmodified WITH ltDTMODI ALL
	GO TOP 
    ?"Last Modified Replaced with",ltDTMODI
    
    lnRecords = 0
    lnRecordBatch=100
	ltDT1 = DATETIME()


	DO WHILE !EOF()
		CURSORTOXML('classes','lcXML',1,0,lnRecordBatch,"1")
        
		IF tView=""
			lnResult=lows9_test.UpLoadDataPaging(lcXML,'classes')
		ELSE
			lnResult=lows9_test.UpLoadDataPagingVIEW(lcXML,'classes')
		ENDIF
		
		IF lnResult#1
		   lnRecordsNotUpdated=XMLTOCURSOR(lcXML,'temp')
	  	   IF lnRecordsNotUpdated#0 AND USED('temp')
	  	   	SELECT temp
	  	   	lcTempFileName=DBF()
	  	   	SELECT Class_NU
	  	   	APPEND FROM (lcTempFileName)
	  	   	
	  	   ENDIF 
		ENDIF
		
		IF RECNO('classes')>=10000
			*!*				* just in case was enough testing
			*!*				SUSPEND 
		ENDIF 
	ENDDO

	ltDT2 = DATETIME()
	?"Duration: ",ltDT2-ltDT1
	USE IN classes
	SELECT class_NU 
	lnCouldNotUpdate=RECCOUNT()
	CLOSE DATABASES ALL
	? "Updated:",lntotalRecords- lnCouldNotUpdate

	RETURN lntotalRecords- lnCouldNotUpdate
ENDPROC
******************************************************


******************************************************
PROCEDURE RunDownLoadDataPagingSinceLastUpdate() AS INTEGER
	* This is a method you need to write to get the last time updated from the web service.
	IF getLasTimeWebServiceUpdatedValue() < DATETIME()
		* Remember you must iterate this call until no records are returned as in the previous example
		lcXML = lows9_test.DownLoadDataPagingSinceLastUpdate("Events",ltLastTimeUpdated,100)
	ELSE
		MESSAGEBOX("Last Time Updated Value Not found.")
	ENDIF
	RETURN
ENDPROC
******************************************************


******************************************************
PROCEDURE getLasTimeWebServiceUpdatedValue
	IF FILE("LastTimeUpdated.TXT")
		RETURN CTOT(FILETOSTR("LastTimeUpdated.TXT"))
	ELSE
		RETURN DATETIME()+100
	ENDIF
ENDPROC
******************************************************


******************************************************
PROCEDURE RunDownLoadALL() AS INTEGER
	?"***  Running "+PROGRAM()
	CLOSE DATABASES ALL
	DELETE FILE "events.dbf"
	?"Start ALL:",DATETIME()
	lcReturnAll = lows9_test.DownLoadALL('events')
	XMLTOCURSOR(lcReturnAll,"EventsALL")
	SELECT * FROM eventsALL INTO TABLE EVENTS
	?"End ALL:",DATETIME()
	RETURN _TALLY
ENDPROC
******************************************************

